tests: remove udf/101
[xfstests-dev.git] / tests / ext4 / 013
1 #! /bin/bash
2 # FS QA Test No. 013
3 #
4 # Create and populate an ext4 filesystem, corrupt an inode, then see how
5 # the kernel and e2fsck deal with it.
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1        # failure is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 15
33
34 _cleanup()
35 {
36     cd /
37     #rm -f $tmp.*
38 }
39
40 # get standard environment, filters and checks
41 . ./common/rc
42 . ./common/filter
43 . ./common/attr
44
45 # real QA test starts here
46 _supported_fs ext4
47 _supported_os Linux
48
49 _require_scratch
50 test -n "${FORCE_FUZZ}" || _require_scratch_ext4_crc
51 _require_attrs
52
53 rm -f $seqres.full
54 TESTDIR="${SCRATCH_MNT}/scratchdir"
55 TESTFILE="${TESTDIR}/testfile"
56
57 echo "+ create scratch fs"
58 _scratch_mkfs_ext4 > /dev/null 2>&1
59
60 echo "+ mount fs image"
61 _scratch_mount
62
63 echo "+ make some files"
64 mkdir -p "${TESTDIR}"
65 for x in `seq 1 1024`; do
66         touch "${SCRATCH_MNT}/junk.${x}"
67         inode="$(stat -c '%i' "${SCRATCH_MNT}/junk.${x}")"
68         if [ "$x" -gt 512 ] && [ "$((inode % 64))" -eq 0 ]; then
69                 mv "${SCRATCH_MNT}/junk.${x}" "${TESTFILE}.1"
70                 break
71         fi
72 done
73 for x in `seq 2 64`; do
74         touch "${TESTFILE}.${x}"
75 done
76 inode="$(stat -c '%i' "${TESTFILE}.1")"
77 umount "${SCRATCH_MNT}"
78
79 echo "+ check fs"
80 e2fsck -fn "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "fsck should not fail"
81
82 echo "+ corrupt image"
83 blk="$(debugfs -R "imap <$inode>" "${SCRATCH_DEV}" 2> /dev/null | grep located | sed -e 's/^.*block \([0-9]*\),.*$/\1/g')"
84 debugfs -w -R "zap_block ${blk}" "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "inode fuzz failed"
85
86 echo "+ mount image"
87 _scratch_mount
88
89 echo "+ modify files"
90 broken=0
91 for x in `seq 1 64`; do
92         #test -e "${TESTFILE}.${x}" || continue
93         stat "${TESTFILE}.${x}" >> $seqres.full 2>&1
94         test $? -ne 0 && broken=1
95         echo moo | dd oflag=append of="${TESTFILE}.${x}" 2>/dev/null
96         test $? -ne 0 && broken=1
97 done
98 echo "broken: ${broken}"
99 umount "${SCRATCH_MNT}"
100
101 echo "+ repair fs"
102 e2fsck -fy "${SCRATCH_DEV}" >> $seqres.full 2>&1
103
104 echo "+ mount image (2)"
105 _scratch_mount
106
107 echo "+ chattr -R -i"
108 $CHATTR_PROG -R -f -i "${SCRATCH_MNT}/"
109
110 echo "+ modify files (2)"
111 broken=0
112 for x in `seq 1 64`; do
113         test -e "${TESTFILE}.${x}" || continue
114         stat "${TESTFILE}.${x}" >> $seqres.full 2>&1
115         test $? -ne 0 && broken=1
116         echo moo | dd oflag=append of="${TESTFILE}.${x}" 2>/dev/null
117         test $? -ne 0 && broken=1
118 done
119 echo "broken: ${broken}"
120 umount "${SCRATCH_MNT}"
121
122 echo "+ check fs (2)"
123 e2fsck -fn "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "fsck should not fail"
124
125 status=0
126 exit